/** \file
 *
 * \brief ATtiny4/5/9/10/20/40pRCUZ
 *
 * ̱ ̧ق͖ړIΏ޲TPICLK݂Ɉ32kHzMɊÂ
 * 8MHzRCU̍ZsZ̧ѳ܂݂܂B
 *
 * \par pLq:
 * AVR057:ATtiny4/5/9/10/20/40pRCUZ
 *
 * \author
 * Atmel Corporation: http://www.atmel.com \n
 * xE-Ұ: avr@atmel.com
 *
 * 쌠 (c) 2010, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

;gpł낤ړIΏ޲BړIΏ޲Ŏw肵Ă!
	.equ ATTINY			= 4
	.include			"defines.inc"

;ėpڼ޽Ɋ蓖Ă̧ѳŎgpϐ
	.def	FLAG_REG		= R17
	.def	STEP_SIZE		= R18
	.def	CPU_TICKS_LOW		= R19
	.def	CPU_TICKS_HIGH		= R20
	.def	OSCCAL_VALUE		= R21
	.def	CYCLE_COUNTER		= R22
	.def	MAX_CALIB_CYCLES	= R23
	.def	CALIB_STATUS		= R24

;ړIΏۓRCUg
	.equ	TARGET_FREQ		= 8000000

;ZQƊۯg
;TPI݊TPICLK(ATmega324PD4)Ŏg𑪒肵A̒lXVĂ
;BۯMAVROSPł̈ȉ̖߂ATmega324PD4݂œ邱Ƃł܂B
; avrosp.exe -dattiny10 -Y
;eX޲ɑ΂޲ύXĂB
	.equ	CALIB_CLOCK_FREQ	= 31800

;Z̐xB1́}1%xӖ܂B
;(1ł͂Ȃ)ŏl1w肵Ă
	.equ	ACCURACY		= 1

;}1%xɑ΂RCUgx
	.equ	TARGET_UP_LIMIT		= (TARGET_FREQ + ((TARGET_FREQ*ACCURACY)/100))
	.equ	TARGET_DOWN_LIMIT	= (TARGET_FREQ - ((TARGET_FREQ*ACCURACY)/100))

;40Zɑ΂RCۯvx
	.equ	EXPECTED_CPU_CYCLES	= ((40*TARGET_FREQ)/CALIB_CLOCK_FREQ)
	.equ	MAX_CPU_CYCLES		= ((40*TARGET_UP_LIMIT)/CALIB_CLOCK_FREQ)
	.equ	MIN_CPU_CYCLES		= ((40*TARGET_DOWN_LIMIT)/CALIB_CLOCK_FREQ)

;iKʂ͍ől(255)̔łB
	.equ	START_STEP_SIZE		= 127

;庰ނ͂Jn
	.org	0x000
	RJMP	START
	.org	INT_VECT
	RJMP PCINT_vect

	;ύXیlCCPڼ޽ɐݒ
START:	LDI	R16,0xD8
	OUT	CCP,R16
	;ۯƂ8MHzRCUI
	LDI	R16,0x00
	OUT	CLKMSR,R16

	;ύXیlCCPڼ޽ɐݒ
	LDI	R16,0xD8
	OUT	CCP,R16
	;ёOu1(Ȃ)ؾāB8
	LDI	R16,0x00
	OUT	CLKPSR,R16

	; ߲
	LDI	R16,high(RAMEND)
	OUT	SPH,R16
	LDI	R16,low(RAMEND)
	OUT	SPL,R16

	;TPIDATAo͂ƂāATPICLKٱߕt͂ƂČ`Ԑݒ
	SBI	TDIR,TDATA_PIN
	SBI	TPORT,TDATA_PIN
	SBI	TPORT,TCLK_PIN

	;TPICLK݂łݕω荞݋
	SBI	INT_CTRL_REG,INT_CTRL_BIT
	SBI	INT_MASK_REG,INT_MASK_BIT

	;iK(127)OSCCALɐݒ
	LDI	STEP_SIZE,START_STEP_SIZE
	LDI	OSCCAL_VALUE,START_STEP_SIZE
	OUT	OSCCAL,OSCCAL_VALUE

	;ϐ
	LDI	CYCLE_COUNTER,0x00
	LDI	MAX_CALIB_CYCLES,40
	INC	MAX_CALIB_CYCLES
	LDI	CALIB_STATUS,0x00

	;S̊荞݋
	SEI

	;ZI܂őҋ@BCALIB_STATUS0܂
loop:	SBRC	CALIB_STATUS,0
	RCALL	SEND_OSCCAL
;
	RJMP	loop

PCINT_vect:
	;ݕω荞݂ŉ~[B㏸[ŕA
	SBIC	TPIN,TCLK_PIN
	RETI
;
	;~[ȂAvis(+1)
	INC	CYCLE_COUNTER
	;v킪ől(40)ɒB
	CLZ
	CP	MAX_CALIB_CYCLES,CYCLE_COUNTER
	;őlBȂAv~
	BREQ	STOP_TIMER
;
	;Ȃ΁AvJn
	LDI	R16,TIMER_CTRL_VAL
	OUT	TIMER_CTRL_REG,R16
	RETI

STOP_TIMER:
	LDI	R16,0x00
	OUT	TIMER_CTRL_REG,R16
	LDI	CYCLE_COUNTER,0x00
	;Uv킪~ƁAZI
	RCALL	CALIB_CHECK
	RETI

CALIB_CHECK:
	;2̂߂ɒiKʂ2Ŋ
	LSR	STEP_SIZE

	;vlϐɐݒ肵TCNTڼ޽
	IN	CPU_TICKS_LOW,TIMER_CNT_LO
	IN	CPU_TICKS_HIGH,TIMER_CNT_HI
	LDI	R16,0x00
	OUT	TIMER_CNT_HI,R16
	OUT	TIMER_CNT_LO,R16

	;CPUvx
	CLC
	CLZ
	MOV	R30,CPU_TICKS_LOW
	MOV	R31,CPU_TICKS_HIGH
	SUBI	R30,low(MAX_CPU_CYCLES)
	SBCI	R31,high(MAX_CPU_CYCLES)
	BRCS	CHECK_LOW
;
	BRCC	REDUCE_OSCCAL

CHECK_LOW:
	CLC
	CLZ
	MOV	R30,CPU_TICKS_LOW
	MOV	R31,CPU_TICKS_HIGH
	SUBI	R30,low(MIN_CPU_CYCLES)
	SBCI	R31,high(MIN_CPU_CYCLES)
	BRCS	INCREASE_OSCCAL
;
	BRCC	END_CALIB

	;CPUv傫ȂAiKʂOSCCAL
REDUCE_OSCCAL:
	SUB	OSCCAL_VALUE,STEP_SIZE
	OUT	OSCCAL,OSCCAL_VALUE
	RET

	;CPUvȂAiKʂOSCCAL𑝉
INCREASE_OSCCAL:
	ADD	OSCCAL_VALUE,STEP_SIZE
	OUT	OSCCAL,OSCCAL_VALUE
	RET

	;CPUvxȂA荞݋֎~CALIB_STATUS̔0ݒɂčZ~
END_CALIB:
	LDI	CALIB_STATUS,0x01
	CBI	TPORT,TDATA_PIN
	RET

	;UZIƁATPICLK݂łHighLow𒮎悵TPIDATAHighLow
	;ޯĒPʂOSCCALl𑗂܂B
SEND_OSCCAL:
	CLI
loop1:
	IN	R16,TPIN
	SBRS	R16,TCLK_PIN
	RJMP	SEND_BIT
;
	RJMP	loop1
SEND_BIT:
	SBRC	OSCCAL_VALUE,7
	SBI	TPORT,TDATA_PIN
;
	SBRS	OSCCAL_VALUE,7
	CBI	TPORT,TDATA_PIN
;
	LSL	OSCCAL_VALUE
loop2:
	IN	R16,TPIN
	SBRC	R16,TCLK_PIN
	RJMP	loop1
;
	RJMP	loop2

/* ̧ق̍Ō */
