cls
@echo off
	@ECHO *********************************************************
	@ECHO  Batch file for calibration of Atmel AVR TINY4/5/9/10/20/40
	@ECHO  oscillator through the TPI interface with AVR918 

	@ECHO  - The internal RC is calibrated to value and accuracy 
	@ECHO    given in AVR057.asm 
	@ECHO  - Programming calibration firmware is performed initially.
	@ECHO  
	@ECHO  $Name$
	@ECHO  $Revision: 3900 $                            
	@ECHO  $RCSfile$
	@ECHO  $Date: 2008-04-30 14:28:26 +0200 (on, 30 apr 2008) $
	@ECHO *********************************************************
	
	@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO   ** S T A R T   P R O G R A M M I N G **
	@ECHO.		
@ECHO ---------------------------------------------------------


@REM ȂCPU`۸ݸ °قւ ߽𖞂ĂB
@SET CPU=attiny4
@SET TOOL=avrosp.exe
@SET CUSTOMERCODE="user.hex"

mode com1 baud=115200 parity=n data=8

%TOOL% -d%CPU% -s -e -pf -vf -ifavr057.hex

@IF ERRORLEVEL ==1 GOTO prog_Calib_code_error

@ECHO ==========================================================
@ECHO Z̧ѳ͖ړIΏۂ֐ɏ܂B
@ECHO ==========================================================
@ECHO.
@ECHO ړIΏۂdOFF/ONATPI݊ؾĂEnterĂB!!!
@ECHO.
@pause

@ECHO.
@ECHO  ** ql̺ޏ݂㑱ZJn
@ECHO  ** OSCCALli[邽߂-Y߂ׯ޲ ڽw肵ĂB

@ECHO ---------------------------------------------------------
%TOOL% -d%CPU% -Y1FF -e -pf -if%CUSTOMERCODE%

@IF ERRORLEVEL ==1 GOTO Calibration_error

	@ECHO.
	@ECHO *********************************************************
	@ECHO 		    O K
	@ECHO *********************************************************
	@PAUSE

@GOTO END

:prog_Calib_code_error
	@ECHO.
@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO 		 
	@ECHO AVRւ̍Z۸яݎs
	@ECHO ݒ~
	@PAUSE
	@GOTO END
@ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


:Calibration_error
	@ECHO.
@ECHO ---------------------------------------------------------
	@ECHO.
	@ECHO 		 
	@ECHO Z/ݎs
	@ECHO ݒ~
	@PAUSE
	@GOTO END
@ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

:END
